#include <stdio.h>
#include "fastio.h"

int last_result = 0;

void* openFile(char *fn, char *mode)
{
  FILE * f = fopen(fn, mode);
  return f;
}

void closeFile(void *file)
{
  last_result = fclose((FILE*)file) == 0;
}

int isEOF(void *file)
{
  int eof = feof((FILE*)file);
  return eof;
}

char   inspectChar  (void * file)
{
  char c;
  long cur;
  int read;
  cur = ftell((FILE*)file);
  read = fscanf((FILE*)file, "%c", &c);
  fseek((FILE*)file, cur, SEEK_SET);
  if (read == 1) {
    return c;
  } else {
    return 0;
  }
}
 

int unsafe_fscanfInt(void *file)
{
  int i;
  last_result = fscanf((FILE*)file, "%d", &i) == 1;
  return i;
}

char unsafe_fscanfChar(void *file)
{
  char c;
  last_result = fscanf((FILE*)file, "%c", &c) == 1;
  return c;
}

float unsafe_fscanfFloat(void *file)
{
  float f;
  last_result = fscanf((FILE*)file, "%f", &f) == 1;
  return f;
}


int fileError(void *file)
{
  int i;
  if (last_result == 1) { return 0; } else {
    i = ferror((FILE*)file);
    return (i>0)?i:1;
  }
}

void fprintfInt   (void *file, int   v) { fprintf((FILE*)file, "%d", v); }
void fprintfChar  (void *file, char  v) { fprintf((FILE*)file, "%c", v); }
void fprintfFloat (void *file, float v) { fprintf((FILE*)file, "%f", v); }
void fprintfString(void *file, char *v) { fprintf((FILE*)file, "%s", v); }

int unsafe_freadInt(void *file)
{
  int v;
  last_result = fread(&v, sizeof(int), 1, (FILE*)file) == 1;
  return v;
}

char unsafe_freadChar(void *file)
{
  char v;
  last_result = fread(&v, sizeof(char), 1, (FILE*)file) == 1;
  return v;
}

float unsafe_freadFloat(void *file)
{
  float v;
  last_result = fread(&v, sizeof(float), 1, (FILE*)file) == 1;
  return v;
}

void fwriteInt  (void *file, int   v) { fwrite(&v, sizeof(int  ), 1, (FILE*)file); }
void fwriteChar (void *file, char  v) { fwrite(&v, sizeof(char ), 1, (FILE*)file); }
void fwriteFloat(void *file, float v) { fwrite(&v, sizeof(float), 1, (FILE*)file); }

